  } else if (strcmp(argv[1],"tiling1bpp")==0) {
    CheckUsage(argc,3,"tiling1bpp","tiles.txt in.g out.g");
    Img0=AllocMemAndLoadGreyImage(argv[3]);
    tiling1bpp(argv[2]);
    SaveImage(argv[4],Img0);


//**** tiling1bpp
// Takes a 1bpp image in entry and tiles it Surt like.
void tiling1bpp(name) char *name; {
  unsigned int width0,height0,NbHorizontalZones,NbVerticalZones;
  unsigned int i,HorizontalZone,VerticalZone,xZone,yZone,ymod,xmod,x,y;
  unsigned int ImgPixel,TilePixel;
  unsigned int MinIndex,MinTotalError,TotalError;
  unsigned int NbTiles;
  int MinDeltaError,DeltaError;
  unsigned int *Tiles,*UpError,*DownError;
  unsigned char *File;
  unsigned char c;
  int FileLength,Nb01,TileSize;
  
  //load file containing Tiles in 0/1 format
  filep=fopen(name,"rb"); // rb = read binary
  if(filep==0) { ErrorInFile(name,"not found"); }
  fseek(filep,0,2); // set the file pointer at the end of file
  FileLength=(int) ftell(filep); // returns the length of the file in bytes
  fseek(filep,0,0); // set the file pointer at the start of file
  File=(unsigned char *) malloc(FileLength); // allocate memory
  fread(File,1,FileLength,filep); // load file, 1=size of a byte
  //Count the number of 0s and 1s in file and allocate memory
  TileSize=0;
  Nb01=0;
  for(i=0;i<FileLength;i++) {
    switch(File[i]) {
      case '0':case '1': Nb01++; break;
      case 10: if(TileSize==0) { TileSize=Nb01; } break;
    }
  }
  NbTiles=Nb01/(TileSize*TileSize);
  UpError=(unsigned int *) malloc(NbTiles*sizeof(unsigned int));
  DownError=(unsigned int *) malloc(NbTiles*sizeof(unsigned int));
  Tiles=(unsigned int *) malloc(Nb01*sizeof(unsigned int));
  //read Tiles
  x=0;
  for(i=0;i<FileLength;i++) {
    c=File[i]-'0';
    if((c==0) || (c==1)) {
      Tiles[x]=c;
      x++;
    }
  }
  
  printf("%d values = %d tiles of size %dx%d  ",Nb01,NbTiles,TileSize,TileSize);
//!!!  for(x=0;x<Nb01;x++) { printf("%d",Tiles[x]); }
  
  //do tiling
  width0=Img0.Adress[0];
  height0=Img0.Adress[1];
  NbHorizontalZones=width0/TileSize;
  NbVerticalZones=height0/TileSize;
  for(VerticalZone=0;VerticalZone<NbVerticalZones;VerticalZone++) {
    yZone=VerticalZone*TileSize;
    for(HorizontalZone=0;HorizontalZone<NbHorizontalZones;HorizontalZone++) {
      xZone=HorizontalZone*TileSize;
      for(i=0;i<NbTiles;i++) { UpError[i]=0; DownError[i]=0; }
      //Count errors if we were to replace zone by a tile. Do for every tile.
      for(ymod=0;ymod<TileSize;ymod++) {
        y=yZone+ymod;
        for(xmod=0;xmod<TileSize;xmod++) {
          x=xZone+xmod;
          ImgPixel=Img0.Adress[2+width0*y+x];
          for(i=0;i<NbTiles;i++) {
            TilePixel=Tiles[i*TileSize*TileSize+ymod*TileSize+xmod];
            if(TilePixel>ImgPixel) { UpError[i]++; }
            if(TilePixel<ImgPixel) { DownError[i]++; }
          }
        } // next xmod
      } // next ymod
      
      //Search tile with minimal TotalError=UpError+DownError. If more than one
      // tile has minimal error, prefer the one with lowest max(UpError-DownError).
      MinIndex=0;
      MinTotalError=UpError[0]+DownError[0];
      MinDeltaError=UpError[0]-DownError[0]; if(MinDeltaError<0) { MinDeltaError=-MinDeltaError; }
      for(i=1;i<NbTiles;i++) {
        TotalError=UpError[i]+DownError[i];
        if(TotalError<=MinTotalError) {
          DeltaError=UpError[i]-DownError[i]; if(DeltaError<0) { DeltaError=-DeltaError; }
          if(DeltaError<MinDeltaError) {
            MinIndex=i;
            MinTotalError=TotalError;
            MinDeltaError=DeltaError;
          }
        }
      }
      
      //Replace zone with "best" tile
      for(ymod=0;ymod<TileSize;ymod++) {
        y=yZone+ymod;
        for(xmod=0;xmod<TileSize;xmod++) {
          x=xZone+xmod;
          Img0.Adress[2+width0*y+x]=Tiles[MinIndex*TileSize*TileSize+ymod*TileSize+xmod];
        } // next xmod
      } // next ymod
      
    } // next HorizontalZone
  } // next VerticalZone
  
}    
